﻿namespace ConsoleApp1
{
    internal class Program
    {
        static AsyncMutex m = new AsyncMutex(@"Global\MyMutex");

        static void Main(string[] args)
        {
            Task t1 = Task.Run(async () =>
            {
                await PrintOut();
            });

            Task t2 = Task.Run(async () =>
            {
                await PrintOut();
            });

            t1.Wait();
            t2.Wait();
        }

        static async Task PrintOut()
        {
            await m.AcquireAsync(CancellationToken.None);
            await m.AcquireAsync(CancellationToken.None);
            Console.WriteLine($"{DateTime.Now:T} [{Thread.CurrentThread.ManagedThreadId}]: PrintOut-EX-before");
            Thread.Sleep(2000);
            Console.WriteLine($"{DateTime.Now:T} [{Thread.CurrentThread.ManagedThreadId}]: PrintOut-EX-after");
            await m.ReleaseAsync();
            await m.ReleaseAsync();
        }
    }
}